package com.jz.common.utils;

import java.security.MessageDigest;
import java.util.Random;

import org.apache.commons.codec.binary.Hex;

/**
 * MD5加盐加密
 */
public class PasswordUtil {
	/**
	 * 生成含有随机盐的密码
	 */
	public static String generate(String password) {
		Random r = new Random();
		StringBuilder sb = new StringBuilder(16);
		sb.append(r.nextInt(99999999)).append(r.nextInt(99999999));
		int len = sb.length();
		if (len < 16) {
			for (int i = 0; i < 16 - len; i++) {
				sb.append("0");
			}
		}
		String salt = sb.toString();
		password = md5Hex(password + salt);
		char[] cs = new char[48];
		for (int i = 0; i < 48; i += 3) {
			cs[i] = password.charAt(i / 3 * 2);
			char c = salt.charAt(i / 3);
			cs[i + 1] = c;
			cs[i + 2] = password.charAt(i / 3 * 2 + 1);
		}
		return new String(cs);
	}

	/**
	 * 生成含有随机盐的密码
	 */
	public static String generateMd5(String password, String salt) {

		password = md5Hex(password + salt);
		// char[] cs = new char[48];
		// for (int i = 0; i < 48; i += 3) {
		// cs[i] = password.charAt(i / 3 * 2);
		// char c = salt.charAt(i / 3);
		// cs[i + 1] = c;
		// cs[i + 2] = password.charAt(i / 3 * 2 + 1);
		// }
		return password;
	}

	/**
	 * 校验密码是否正确
	 */
	public static boolean verify(String password, String md5) {
		char[] cs1 = new char[32];
		char[] cs2 = new char[16];
		for (int i = 0; i < 48; i += 3) {
			cs1[i / 3 * 2] = md5.charAt(i);
			cs1[i / 3 * 2 + 1] = md5.charAt(i + 2);
			cs2[i / 3] = md5.charAt(i + 1);
		}
		String salt = new String(cs2);
//		System.out.println("取出盐值" + salt);
		return md5Hex(password + salt).equals(new String(cs1));
	}

	/**
	 * 获取十六进制字符串形式的MD5摘要
	 */
	public static String md5Hex(String src) {
		try {
			MessageDigest md5 = MessageDigest.getInstance("MD5");
			byte[] bs = md5.digest(src.getBytes());
			return new String(new Hex().encode(bs));
		} catch (Exception e) {
			return null;
		}
	}

	public static void main(String[] args) {
		// 27756851e315a3f124a6505b795177b0d664d1d64dd3da0c
		// System.out.println(verify("123456","409c2a69a24ed6db30e25a3ba56993103a8966657842ad2a"));
		//
		// String pwd1=generateMd5("123456","admin");
		// String pwd2= generate(pwd1);
		// System.out.println("pwa1===="+pwd1);
		// System.out.println("pwa2===="+pwd2);
		// System.out.println(verify(pwd1, pwd2));
		 String password1 = generate("111111");
//a1ee17a8d73db50f99b72a5249b86bc2f10cc3105324b28e
		 System.out.println("结果：" + password1 +"验证"+ verify("111111", password1));
		// 加密+加盐

	}

	
}